<html>
<head>
  <link href="css/topic_graph.css" rel="stylesheet" type="text/css">
  <script src="js/jquery.min.js"></script>
  <script type="text/javascript" src="js/jquery.flot.min.js"></script>
  <script type="text/javascript" src="js/jquery.flot.pie.min.js"></script>


<script type="text/javascript">
var b = "dfd"
var keys = []
function set_topics_data(r){
    b = $.parseJSON(r);
    for (var key in b) {
	keys.push(parseInt(key));
    }    
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
    results = regex.exec(location.search);
    return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

var the_options = $.parseJSON(getParameterByName("options"))

var last_found_key_index = null

//this should come from the loaded data from the server
var number_of_topics = 20;

var pie_options = {
    series: {
	pie: {
	    show: true
	}
    }
}
var bar_options = {
    bars: {show:true},
    xaxis: {min:0,max:number_of_topics},
    yaxis: {labelWidth: 4},
};

options = the_options["graph_type"] == "pie"? pie_options : bar_options;

var old_stuff = []
for (var kk=0;kk<number_of_topics;kk++){
    old_stuff.push(0)
}

function last_found_key_index_reset() {
    last_found_key_index = 0;
}

function graph_it(timestamp){
    var graph_array = []
    for (var j=0; j<number_of_topics; j++) {
      if (b[timestamp][j] != null && b[timestamp][j] != undefined) {
	  graph_array.push([j, b[timestamp][j]])
      } else {
	  graph_array.push([j, parseInt(old_stuff[j][1])/2])
      }
  }
    //blow out each point into its own series to get different bar colors. conforming data to what flot likes for multi colors essentially.
    var series_array = []
    for (var k=0;k<graph_array.length;k++){
	series_array.push([graph_array[k]]);
    }
    $.plot("#placeholder", series_array, options)
    old_stuff = graph_array;
}

function graph_at_milisecs(media_time) {
    if (last_found_key_index == null) {last_found_key_index = 0 }
    var closest_timestamp = find_closest_timestamp(keys, media_time)
    if (closest_timestamp) last_found_key_index = keys.indexOf(closest_timestamp)
    graph_it(closest_timestamp)
}

function find_closest_timestamp(array, goal) {
    var closest = null
    for (var k=last_found_key_index; k<array.length; k++) {
	if (closest == null || Math.abs(parseInt(array[k]) - goal) < Math.abs(closest - goal)) {
	    closest = parseInt(array[k]);
	} else {
	    if (Math.abs(closest - goal) < Math.abs(parseInt(array[k]) - goal)) {
		k = array.length; //stop the looping
		return closest;
	    }
	}
    }
}
var graph_toggle = 0
function change_graph_type() {
    options == bar_options ? graph_toggle = 0 : graph_toggle = 1
    if (graph_toggle % 2) {
	options = bar_options
    } else {
	options = pie_options
    }
    graph_toggle += 1;
}

</script>
</head>

<body>

<a href="#" onclick="change_graph_type()">Toggle graph type</a>
<div id="placeholder" class="demo-placeholder">


</div>

</body>
</html>

